<?php
/*
Plugin Name: Photopress2
Plugin URI: http://familypress.net/photopress2/
Description: Adds some new ways to display your Media Library images: an album, a widget, and a shortcode.
Author: Isaac Wedin
Version: 0.3
Author URI: http://familypress.net
*/

/* Copyright 2010 Isaac Wedin (email : isaac@familypress.net)
This program is free software; you can redistribute it and/or modify it under th
e terms of the GNU General Public License as published by the Free Software Foun
dation; either version 2 of the License, or (at your option) any later version. 
http://www.opensource.org/licenses/gpl-license.php

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
PARTICULAR PURPOSE.  See the GNU General Public License for more details. */

// get options, set defaults if empty
$photopress2_options = get_option('photopress2_options');
if (empty($photopress2_options['display']))
	$photopress2_options['display'] = 'thumbnail';
if (empty($photopress2_options['style']))
	$photopress2_options['style'] = 'yes';
if (empty($photopress2_options['pagename']))
	$photopress2_options['pagename'] = 'photos';
if (empty($photopress2_options['caching']))
	$photopress2_options['caching'] = 'yes';
if (empty($photopress2_options['thickbox']))
	$photopress2_options['thickbox'] = 'yes';

function photopress2_options_init() {
	register_setting('photopress2options_options','photopress2_options','photopress2_sanitize');
}

add_action('admin_init','photopress2_options_init');

function photopress2_sanitize($input) {
		wp_enqueue_style('thickbox');
		wp_enqueue_style('thickbox');
	global $photopress2_options;
	$input['display'] = wp_filter_nohtml_kses($input['display']);
	$input['style'] = wp_filter_nohtml_kses($input['style']);
	$input['pagename'] = wp_filter_nohtml_kses($input['pagename']);
	$input['caching'] = wp_filter_nohtml_kses($input['caching']);
	$input['thickbox'] = wp_filter_nohtml_kses($input['thickbox']);
	return $input;
}

function photopress2_add_options_page() {
	add_options_page('Photopress 2', 'Photopress 2', 'manage_options', 'photopress2_options', 'photopress2_options_subpanel');
}

add_action('admin_menu', 'photopress2_add_options_page');

// generates the Photopress2 Options subpanel
function photopress2_options_subpanel() {
	global $photopress2_options,$wp_rewrite;
	echo '
	<div class="wrap">
	<h2>' . __('Photopress2 options','photopress2') . '</h2>
	<form method="post" action="options.php">
';
	settings_fields('photopress2options_options');
	echo '
	<fieldset class="options">
	<table class="form-table">
		<tbody>
      <tr>
         <th scope="row">' . __('Album format:','photopress2') . "</th>\n<td>";
	if (empty($photopress2_options['display']) || ($photopress2_options['display'] == 'thumbnail')) {
		echo '<label><input name="photopress2_options[display]" type="radio" value="thumbnail" size="5" checked="checked"> thumbnail</label><br /><label><input name="photopress2_options[display]" type="radio" value="medium" size="5"> medium</label><br />';
	} else {
		echo '<label><input name="photopress2_options[display]" type="radio" value="thumbnail" size="5"> thumbnail</label><br /><label><input name="photopress2_options[display]" type="radio" value="medium" size="5" checked="checked"> medium</label><br />';
	}
	echo __('The album can show either thumbnails or medium-sized images.','photopress2') . '</td>
      </tr>
		<tr>
         <th scope="row">' . __('Insert album style:','photopress2') . "</th>\n<td>";
   if (empty($photopress2_options['style']) || ($photopress2_options['style'] == 'yes')) {
      echo '<label><input name="photopress2_options[style]" type="radio" value="yes" size="5" checked="checked"> yes</label><br /><label><input name="photopress2_options[style]" type="radio" value="no" size="5"> no</label><br />';
   } else {
      echo '<label><input name="photopress2_options[style]" type="radio" value="yes" size="5"> yes</label><br /><label><input name="photopress2_options[style]" type="radio" value="no" size="5" checked="checked"> no</label><br />';
   }
   echo __('This will add some default CSS that should work for many themes. If you do not like how it looks, disable this option and add custom style to your theme.','photopress2') . '</td>
		</tr>
		<tr>
			<th scope="row">' . __('Album page name:','photopress2') . '</th>
			<td><input name="photopress2_options[pagename]" type="text" value="' . $photopress2_options['pagename'] . '" size="10" /><br />' . __('Enter your album page slug here.','photopress2') . '</td>
		</tr>
      <tr>
         <th scope="row">' . __('Use caching:','photopress2') . "</th>\n<td>";
   if (empty($photopress2_options['caching']) || ($photopress2_options['caching'] == 'yes')) {
      echo '<label><input name="photopress2_options[caching]" type="radio" value="yes" size="5" checked="checked"> yes</label><br /><label><input name="photopress2_options[caching]" type="radio" value="no" size="5"> no</label><br />';
   } else {
      echo '<label><input name="photopress2_options[caching]" type="radio" value="yes" size="5"> yes</label><br /><label><input name="photopress2_options[caching]" type="radio" value="no" size="5" checked="checked"> no</label><br />';
   }
   echo __('Caching helps reduce resource usage, speeding up album page display.','photopress2') . '</td>
      </tr>
      <tr>
         <th scope="row">' . __('Use ThickBox:','photopress2') . "</th>\n<td>";
   if (empty($photopress2_options['thickbox']) || ($photopress2_options['thickbox'] == 'yes')) {
      echo '<label><input name="photopress2_options[thickbox]" type="radio" value="yes" size="5" checked="checked"> yes</label><br /><label><input name="photopress2_options[thickbox]" type="radio" value="no" size="5"> no</label><br />';
   } else {
      echo '<label><input name="photopress2_options[thickbox]" type="radio" value="yes" size="5"> yes</label><br /><label><input name="photopress2_options[thickbox]" type="radio" value="no" size="5" checked="checked"> no</label><br />';
   }
   echo __('This enables using ThickBox to display unattached images. Attached images are still displayed on attachment pages.','photopress2') . '</td>
      </tr>
	</tbody>
	</table> 
	</fieldset>
	<p class="submit"><input type="submit" name="Submit" value="' . __('Update Options &raquo;','photopress2') . '" /></p>
</form> 
</div>
	';
	$wp_rewrite->flush_rules(); // this should work but is lame
	photopress2_clear_cache();
}

function photopress2_tag_count($tag) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress2_tags";
	$tag_count = $wpdb->get_var("SELECT COUNT(*) FROM $table_name WHERE BINARY tag = '$tag';");
	return $tag_count;
}

function photopress2_tagged_image_count($tag = FALSE) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress2_tags";
	if ($tag) {
		if ($image_count = $wpdb->get_var("SELECT DISTINCT COUNT(attachid) FROM $table_name WHERE BINARY tag = '$tag';")) {
			return $image_count;
		} else {
			return 0;
		}
	} else {
		if ($image_count = $wpdb->get_var("SELECT DISTINCT COUNT(attachid) FROM $table_name;")) {
			return $image_count;
		} else {
			return 0;
		}
	}
}

function photopress2_album_style() {
	global $photopress2_options;
	$pageslug = $photopress2_options['pagename'];
	$page_id = photopress2_get_id_by_slug($pageslug);
	if (($_GET['page_id'] == $page_id) || ($_GET['pagename'] == $photopress2_options['pagename']) || (get_query_var('pagename') == $photopress2_options['pagename'])) {
		$user_style = get_bloginfo('stylesheet_directory') . '/pp2_style.css';
		if (file_exists($user_style)) {
			echo '<link rel="stylesheet" href="' . $user_style  . '" type="text/css" media="screen" />';
		} else {
			$plugin_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
			echo '<link rel="stylesheet" href="' . $plugin_url . 'pp2_style.css" type="text/css" media="screen" />';
		}
	}
	if (($photopress2_options['thickbox'] == 'yes') && (is_active_widget('widget_pp2widg') || ($_GET['page_id'] == $page_id) || ($_GET['pagename'] == $photopress2_options['pagename']) || (get_query_var('pagename') == $photopress2_options['pagename']))) {
		echo '<link rel="stylesheet" id="thickbox-css" href="' . get_option('siteurl') . '/wp-includes/js/thickbox/thickbox.css?ver=20090514" type="text/css" media="all" />';
	}
}

if (empty($photopress2_options['style']) || ($photopress2_options['style'] == 'yes')) {
	add_action('wp_head','photopress2_album_style');
}

function photopress2_album() {
	global $wp_rewrite, $photopress2_options;
	$pageslug = $photopress2_options['pagename'];
	$page_id = photopress2_get_id_by_slug($pageslug);
	$num_posts = (array) wp_count_attachments('image');
	$total_images = array_sum($num_posts) - $num_posts['trash'];
	$image_count_text = '(' . number_format_i18n($total_images) . __(' images','photopress2') . ')';
	if ($wp_rewrite->using_permalinks()) {
		$recentlink = get_permalink($page_id);
		$tagslink = $recentlink . 'tags/';
	} else {
		$recentlink = get_permalink($page_id) . '&amp;pp2_1=';
		$tagslink = $recentlink . 'tags&pp2_2=';
	}
	if ((get_query_var('pp2_1') == 'tags')) { // tags page
		if (get_query_var('pp2_2')) { // display imgages for a tag
			$tag = get_query_var('pp2_2');
			if ($photopress2_options['caching'] == 'yes') {
				$tagcachekey = 'pp2_tag_' . $tag;
				$tag_html = get_transient($tagcachekey);
			}
			if ((false === $tag_html) || ($photopress2_options['caching'] == 'no')) {
				$tag_count = photopress2_tag_count($tag);
				$main_menu = '<p><a href="' . $recentlink . '">' . __('recent','photopress2') . '</a> <a href="' . $tagslink . '">' . __('tags','photopress2') . '</a> <strong>' . $tag . '</strong>' . ' <span class="pp2_graytext">(' . $tag_count . __(' images)','photopress2') . '</span></p>';
				$image_ids = photopress2_images_in_tag($tag);
				$comma_ids = implode(',',$image_ids);
				$album_html = '<div class="pp2_gallery">' . photopress2_get('date',null,'<dl class="pp2_gallery-item"><dt class="pp2_gallery-icon">','</dt></dl>','thumbnail',null,'none',TRUE,"$comma_ids") . '</div><br class="clear" />';
				$tag_html = $main_menu . $album_html;
				if ($photopress2_options['caching'] == 'yes') {
					set_transient($tagcachekey,$tag_html,43200);
				}
				return $tag_html . '<!--not cached-->';
			} else {
				return $tag_html . '<!--cached-->';
			}
		} else { // display the tag list
			if ($photopress2_options['caching'] == 'yes') {
				$tags_html = get_transient('pp2_tagshtml');
			}
			if ((false === $tags_html) || ($photopress2_options['caching'] == 'no')) {
				$tag_count_text = '<span class="pp2_graytext">(' . number_format_i18n(photopress2_tagged_image_count()) . __(' tagged images','photopress2') . ')</span>';
				$main_menu = '<p><a href="' . $recentlink . '">' . __('recent','photopress2') . '</a> <strong>' . __('tags','photopress2') . '</strong> ' . $tag_count_text . '</p>';
				$tags = (array)photopress2_taglist();
				foreach ($tags as $tag) {
					$image_src = photopress2_get_tag_image($tag);
					$image_count = photopress2_tagged_image_count($tag);
					$tagspew .= '<dl class="pp2_gallery-item"><dt class="pp2_gallery-icon"><a href="' . $tagslink . $tag . '"><img src="' . $image_src[0] . '" width="' . $image_src[1] . '" height="' . $image_src[2] . '" alt="' . $tag . '" /></a></dt><dd class="pp2_gallery-caption">' . $tag . ' (' . $image_count . ")</dd></dl>\n";
				}
				$tags_html = $main_menu . '<div class="pp2_gallery">' . $tagspew . '</div>';
				$tags_html .= '<div class="pp2nav">' . $tag_count_text . '</div>';
				if ($photopress2_options['caching'] == 'yes') {
					set_transient('pp2_tagshtml',$tags_html,43200);
				}
				return $tags_html . '<!--not cached-->';
			} else {
				return $tags_html . '<!--cached-->';
			}
		}
	} else { // recent images / main page
		if ($photopress2_options['display'] == 'medium') {
			$per_page = 5;
		} else {
			$per_page = 15;
		}
		if (get_query_var('pp2_1') != '') {
			$current_page = get_query_var('pp2_1');
		} else {
			$current_page = 1;
		}
		if ($photopress2_options['caching'] == 'yes') {
			$recent_cache_key = 'pp2_recent_page' . $current_page;
			$recent_html = get_transient($recent_cache_key);
		}
		if ((false === $recent_html) || ($photopress2_options['caching'] == 'no')) {
			$tagged_image_count = photopress2_tagged_image_count();
			$main_menu = '<p><strong>' . __('recent','photopress2') . '</strong> ';
			if ($tagged_image_count > 0) {
				$main_menu .=  '<a href="' . $tagslink . '">' . __('tags','photopress2') . '</a> ';
			}
			$main_menu .= '<span class="pp2_graytext">' . $image_count_text . '</span></p>';
			$pages = (int)ceil($total_images/$per_page);
			set_transient('pp2_page_count',$pages,86400);
			$offset = ($current_page - 1) * $per_page;
			if ($pages > 1) {
				$page_nav_html = paginate_links( array('base' => $recentlink.'%_%','format' => '%#%','prev_text' => __('&laquo; prev'),'next_text' => __('next &raquo;'),'total' => $pages,'current' => $current_page));
			}
			if ($photopress2_options['display'] == 'medium') {
				$album_html = '<div class="pp2nav">' . $page_nav_html . '</div>' . photopress2_get('date',$per_page,'','','medium',$offset,'center',TRUE) . '<div class="pp2nav">' . $page_nav_html . '</div>';
			} else {
				$album_html = '<div class="pp2nav">' . $page_nav_html . '</div><div class="pp2_gallery">' . photopress2_get('date',$per_page,'<dl class="pp2_gallery-item"><dt class="pp2_gallery-icon">','</dt></dl>','thumbnail',$offset,'none',TRUE) . '</div><div class="pp2nav">' . $page_nav_html . '</div>';
			}
			$album_html .= '<div class="pp2nav"><span class="pp2_graytext">(' . number_format_i18n($total_images) . __(' images','photopress2') . ')</span></div>';
			$recent_html = $main_menu . $album_html;
			if ($photopress2_options['caching'] == 'yes') {
				set_transient($recent_cache_key,$recent_html,43200);
			}
			return $recent_html . '<!--not cached-->';
		} else {
			return $recent_html . '<!--cached-->';
		}
	}
}

// returns the image info for the first attach id associated with a tag
function photopress2_get_tag_image($tag) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress2_tags";
	$row = $wpdb->get_row("SELECT attachid FROM $table_name WHERE tag = '$tag';");
	$image_src = wp_get_attachment_image_src($row->attachid);
	return $image_src;
}

function photopress2_get($orderby = 'date', $number = 3, $before = '<p>', $after = '</p>', $size = 'thumbnail', $offset = 0, $class = 'none', $album = FALSE, $include = FALSE) {
	global $photopress2_options;
	$args = array('offset' => $offset,'post_type' => 'attachment','post_mime_type' => 'image','numberposts' => $number,'orderby' => $orderby);
	if ($include)
		$args['include'] = $include;
	$attachments = get_posts($args);
	if ($attachments) {
		foreach ($attachments as $attachment) {
			setup_postdata($attachment);
			if ($attachment->post_parent == 0) {
				if ($photopress2_options['thickbox'] == 'yes') {
					$attach_url = wp_get_attachment_url($attachment->ID) . '" class="thickbox';
				} else {
					$attach_url = wp_get_attachment_url($attachment->ID);
				}
			} else {
				$attach_url = get_attachment_link($attachment->ID);
			}
			if ($album) {
				if ($image_src = wp_get_attachment_image_src($attachment->ID,$size,false)) {
					if ($size == 'medium') {
						$divwidth = $image_src[1] + 10;
						$linked_images .= '<div class="wp-caption aligncenter" style="width: ' . $divwidth . 'px"><p class="pp2-medium-title">' . $attachment->post_title . '</p><a href="' . $attach_url . '">' . get_image_tag($attachment->ID,$attachment->post_title,$attachment->post_title,$class,$size) . '</a><p class="wp-caption-text">' . __('uploaded ','photopress2') . date_i18n($attachment->post_date) . __(' by ','photopress2') . get_the_author_meta('display_name',$attachment->post_author) . '</p></div>';
					} else {
						if (strlen($attachment->post_title) > 20) {
							$title = substr($attachment->post_title,0,18) . '...';
						} else {
							$title = $attachment->post_title;
						}
						$linked_images .= '<dl class="pp2_gallery-item"><dt class="pp2_gallery-icon"><a href="' . $attach_url . '">' . get_image_tag($attachment->ID,$attachment->post_title,$attachment->post_title,$class,$size) . '</a></dt><dd class="pp2_gallery-caption">' . $title . "</dd></dl>\n";
					}
				}
			} else {
				$linked_images .= $before . '<a href="' . $attach_url . '">' . get_image_tag($attachment->ID,$attachment->post_title,$attachment->post_title,$class,$size) . '</a>' . $after . "\n";
			}
		}
		return $linked_images;
	} else {
		return FALSE;
	}
}

function photopress2tag ($atts) {
	$atts_array = shortcode_atts(array(
		'orderby' => 'date',
		'size' => 'thumbnail',
		'number' => '3',
		'before' => '<p>',
		'after' => '</p>',
		'class' => 'none',
	), $atts);
	if ($photopress2_options['caching'] == 'yes') {
		$cache_key = implode(',',$atts_array);
		$cache_key = 'pp2_' . md5($cache_key);
		$cache_key_list = get_transient('pp2_cache_keys');
		if (false === $cache_key_list) {
			$cache_key_list[] = $cache_key;
			set_transient('pp2_cache_keys',$cache_key_list,86400);
		} else {
			if (!in_array($recent_cache_key,$cache_key_list)) {
				$cache_key_list[] = $cache_key;
				set_transient('pp2_cache_keys',$cache_key_list,86400);
			}
		}
		$images = get_transient($cache_key);
	}
	if ((false === $images) || ($photopress2_options['caching'] == 'no')) {
		extract($atts_array);
		$before = stripslashes(html_entity_decode($before,ENT_QUOTES));
		$after = stripslashes(html_entity_decode($after,ENT_QUOTES));
		$images = photopress2_get($orderby, $number, $before, $after,'thumbnail',0,$class,FALSE,FALSE);
		if ($photopress2_options['caching'] == 'yes') {
			set_transient($cache_key,$images,43200);
		}
		return $images . '<!--not cached-->';
	} else {
		return $images . '<!--cached-->';
	}
}

add_shortcode('photopress2', 'photopress2tag');

function photopress2_add_query_var($wpvar_array) {
	$wpvar_array[] = 'pp2_1';
	$wpvar_array[] = 'pp2_2';
	return $wpvar_array;
}

add_filter('query_vars','photopress2_add_query_var');

function photopress2_add_rewrite_rules($rules) {
	global $photopress2_options;
	$pagename = $photopress2_options['pagename'];
	$newrules = array();
	$rulekey1 = $pagename . '/([A-Za-z0-9-]+)/([A-Za-z0-9-]+)?/?$';
	$rulekey2 = $pagename . '/([A-Za-z0-9-]+)/?$';
	$newrules[$rulekey1] = 'index.php?pagename=' . $pagename . '&pp2_1=$matches[1]&pp2_2=$matches[2]';
	$newrules[$rulekey2] = 'index.php?pagename=' . $pagename . '&pp2_1=$matches[1]';
	return $newrules + $rules;
}

add_filter('rewrite_rules_array', 'photopress2_add_rewrite_rules');

function photopress2_album_insert($content = '') {
	if ( ('' == $content) || (! strstr($content, 'pp2_album')) ) { return $content; }
	return preg_replace('|(<p>)?(\n)*<!--pp2_album-->(\n)*(</p>)?|', photopress2_album(), $content);
}

add_filter('the_content', 'photopress2_album_insert');

function widget_pp2widg_init() {
	if ( !function_exists('register_sidebar_widget') || !function_exists('photopress2_get'))
		return;
	function widget_pp2widg($args) {
		global $photopress2_options;
		extract($args);
		$options = get_option('widget_pp2widg');
// I don't want any title stuff for an empty title option, but I want to allow zero for a title...pretty silly.
		if (strlen($options['title']) > 0) {
			$title = $before_title . $options['title'] . $after_title;
		}
		$class = $options['pp2_class'];
		$orderby = $options['orderby'];
		$after = stripslashes(html_entity_decode($options['after'],ENT_QUOTES));
		$before = stripslashes(html_entity_decode($options['before'],ENT_QUOTES));
		$numphotos = (int)$options['number'];
		if ($photopress2_options['caching'] == 'yes') {
			if ($orderby == 'rand') { // per-page cache for rand, not for recent
				global $post;
				$cache_key = $post->ID . $orderby . ',' . $numphotos . ',' . $before . ',' . $after . ',' . 'thumbnail,0,' . $class . ',FALSE,FALSE';
			} else {
				$cache_key = $orderby . ',' . $numphotos . ',' . $before . ',' . $after . ',' . 'thumbnail,0,' . $class . ',FALSE,FALSE';
			}
			$cache_key = 'pp2_' . md5($cache_key);
			$cache_key_list = get_transient('pp2_cache_keys');
			if (false === $cache_key_list) {
				$cache_key_list[] = $cache_key;
				set_transient('pp2_cache_keys',$cache_key_list,86400);
			} else {
				if (!in_array($recent_cache_key,$cache_key_list)) {
					$cache_key_list[] = $cache_key;
					set_transient('pp2_cache_keys',$cache_key_list,86400);
				}
			}
			$images = get_transient($cache_key);
		}
		if ((FALSE === $images) || ($photopress2_options['caching'] == 'no')) {
			$images = photopress2_get($orderby,$numphotos,$before,$after,'thumbnail',0,$class,FALSE,FALSE);
			if ($photopress2_options['caching'] == 'yes') {
				set_transient($cache_key,$images,43200);
			}
			$images = $images . '<!--not cached-->';
		} else {
			$images = $images . '<!--cached-->';
		}
		echo $before_widget . $title . $images . $after_widget;
	}

	function widget_pp2widg_control() {
		$options = get_option('widget_pp2widg');
		if ( !is_array($options) )
			$options = array('title'=>'', 'number'=>'1', 'orderby'=>'date', 'before'=>'<p>', 'after'=>'</p>', 'pp2_class'=>'center');
		if ( $_POST['pp2widg-submit'] ) {
			$options['title'] = strip_tags(stripslashes($_POST['pp2widg-title']));
			$options['pp2_class'] = strip_tags(stripslashes($_POST['pp2widg-pp2_class']));
			$options['number'] = strip_tags(stripslashes($_POST['pp2widg-number']));
			$options['orderby'] = strip_tags(stripslashes($_POST['pp2widg-orderby']));
			// Swap double for single quotes.
			$options['before'] = htmlentities(str_replace('"',"'",$_POST['pp2widg-before']),ENT_QUOTES);
			$options['after'] = htmlentities(str_replace('"',"'",$_POST['pp2widg-after']),ENT_QUOTES);
			update_option('widget_pp2widg', $options);
		}
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$class = htmlspecialchars($options['pp2_class'], ENT_QUOTES);
		$orderby = htmlspecialchars($options['orderby'], ENT_QUOTES);
		$before = stripslashes(html_entity_decode($options['before'], ENT_QUOTES));
		$after = stripslashes(html_entity_decode($options['after'], ENT_QUOTES));
		$number = (int)$options['number'];
		// Here is our little form segment. Notice that we don't need a
		// complete form. This will be embedded into the existing form.
		echo '<p style="text-align:right;"><label for="pp2widg-title">' . __('Title:') . ' <input style="width: 100px;" id="pp2widg-title" name="pp2widg-title" type="text" value="'.$title.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="pp2widg-pp2_class">' . __('Image class:') . ' <input style="width: 100px;" id="pp2widg-pp2_class" name="pp2widg-pp2_class" type="text" value="'.$class.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="pp2widg-before">' . __('Before each image:') . ' <input style="width: 100px;" id="pp2widg-before" name="pp2widg-before" type="text" value="'.$before.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="pp2widg-after">' . __('After each image:') . ' <input style="width: 100px;" id="pp2widg-after" name="pp2widg-after" type="text" value="'.$after.'" /></label></p>';
		echo '<p style="text-align:right;"><label for="pp2widg-orderby">' . __('Random or recent:') . '<select id="pp2widg-orderby" name="pp2widg-orderby"' . ">\n";
		echo '<option value="date"';
		if ($orderby == 'date')
			echo ' selected="selected"';
		echo '>' . __('recent','photopress2') . '</option><option value="rand"';
		if ($orderby == 'rand')
			echo ' selected="selected"';
		echo ">" . __('random','photopress2') . "</option></select>\n</label></p>";
		echo '<p style="text-align:right;"><label for="pp2widg-number">' . __('Number of images:') . '<select id="pp2widg-number" name="pp2widg-number"' . ">\n";
		for ($i=1;$i<=10;$i++) {
			echo '<option value="' . $i . '"';
				if ($number == $i) {
					echo ' selected="selected"';
				}
			echo '>' . $i . "</option>\n";
      }
		echo "</select>\n" . '</label></p>';
		echo '<input type="hidden" id="pp2widg-submit" name="pp2widg-submit" value="1" />';
	}
	// This registers our widget so it appears with the other available
	// widgets and can be dragged and dropped into any active sidebars.
	register_sidebar_widget(array('Photopress2', 'widgets'), 'widget_pp2widg');
	// This registers our optional widget control form. Because of this
	// our widget will have a button that reveals a 300x100 pixel form.
	register_widget_control(array('Photopress2', 'widgets'), 'widget_pp2widg_control');
}

add_action('widgets_init', 'widget_pp2widg_init');

function photopress2_table_install() {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress2_tags";
	$pp_table_name = $table_prefix . "photopress";
	if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
		$sql = "CREATE TABLE ".$table_name." (tag text NULL, attachid bigint(20) NULL);";
		require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
		dbDelta($sql);
		add_option('pp2_db_version', '3');
		if($wpdb->get_var("show tables like '$pp_table_name'")) {
			$images = $wpdb->get_results("SELECT catslug,attachid FROM $pp_table_name",ARRAY_A);
			foreach ($images as $image) {
				if ($image['catslug'] != 'default') {
					$catslug = $image['catslug'];
					$attachid = $image['attachid'];
					$wpdb->query("INSERT INTO $table_name SET tag='$catslug', attachid='$attachid';");
				}
			}
		}
	}
}

register_activation_hook( __FILE__, 'photopress2_table_install');

function photopress2_images_in_tag($tag) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress2_tags";
	$images = (array)$wpdb->get_col("SELECT attachid FROM $table_name WHERE BINARY tag = '$tag'");
	return $images;
}

function photopress2_taglist($id = FALSE) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress2_tags";
	if (FALSE === $id) {
		$tags = (array)$wpdb->get_col("SELECT DISTINCT tag FROM $table_name");
	} else {
		$tags = (array)$wpdb->get_col("SELECT tag FROM $table_name WHERE BINARY attachid = '$id';");
	}
	sort($tags);
	return $tags;
}

function photopress2_update_tags($tags,$id) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress2_tags";
	$wpdb->query("DELETE FROM $table_name WHERE binary attachid = '$id'");
	foreach ($tags as $tag) {
		$sanitag = trim($tag);
		$sanitag = sanitize_title_with_dashes($sanitag);
		$wpdb->query("INSERT INTO $table_name SET tag='$sanitag', attachid='$id';");
		$tag_cache = 'pp2_tag_' . $tag;
		delete_transient($tag_cache);
		delete_transient('pp2_tagshtml');
	}
}

function photopress2_attachment_fields_to_save($post, $attachment) {
	if (strlen($attachment['pp2tags'])) {
		$tags = trim($attachment['pp2tags']);
		$tags = trim($tags,',');
		if (strpos($tags,',')) {
			$tagsarray = explode(',',$tags);
		} else {
			$tagsarray[] = $tags;
		}
		photopress2_update_tags($tagsarray,$post['ID']);
	}
	return $post;
}

add_filter('attachment_fields_to_save','photopress2_attachment_fields_to_save',11,2);

function photopress2_attachment_fields_to_edit($form_fields, $post) {
	if ( substr($post->post_mime_type, 0, 5) == 'image' ) {
		if ($tags = photopress2_taglist($post->ID)) {
			$commatags = implode(',',$tags);
		}
		$form_fields['pp2tags'] = array(
			'label' => 'Tags',
			'input' => 'html',
			'html' => "<input type='text' class='text' name='attachments[$post->ID][pp2tags]' id='attachments[$post->ID][pp2tags]' value='$commatags' /><br /><p class='help'>Enter tags here, separated by commas. All tags are lowercased and any funny characters, including spaces, are converted to dashes.</p>",
		);
	}
	return $form_fields;
}

add_filter('attachment_fields_to_edit','photopress2_attachment_fields_to_edit',10,2);

function photopress2_clear_cache() {
	$cache_key_list = get_transient('pp2_cache_keys');
	if (FALSE !== $cache_key_list) {
		foreach ($cache_key_list as $cache_key) {
			delete_transient($cache_key);
		}
		delete_transient('pp2_cache_keys');
	}
	$page_count = get_transient('pp2_page_count');
	for ($i=1; $i <= $page_count; $i++) {
		$recent_cache = 'pp2_recent_page' . $i;
		delete_transient($recent_cache);
	}
	delete_transient('pp2_page_count');
	$tags = (array)photopress2_taglist();
	foreach ($tags as $tag) {
		$tag_cache = 'pp2_tag_' . $tag;
		delete_transient($tag_cache);
	}
	delete_transient('pp2_tagshtml');
}

if ($photopress2_options['caching'] == 'yes') {
	add_action('add_attachment','photopress2_clear_cache');
	add_action('edit_attachment','photopress2_clear_cache');
	add_action('delete_attachment','photopress2_clear_cache');
	add_action('permalink_structure_changed','photopress2_clear_cache');
}

function photopress2_get_id_by_slug($slug) {
	global $wpdb;
	if ($id = $wpdb->get_row( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_name = '%s' AND post_status = 'publish'", $slug))) {
		return $id->ID;
	} else {
		return FALSE;
	}
}

function photopress2_scripts() {
	global $photopress2_options;
	$pageslug = $photopress2_options['pagename'];
	$page_id = photopress2_get_id_by_slug($pageslug);
	if (($photopress2_options['thickbox'] == 'yes') && (is_active_widget('widget_pp2widg') || ($_GET['page_id'] == $page_id) || ($_GET['pagename'] == $photopress2_options['pagename']) || (get_query_var('pagename') == $photopress2_options['pagename']))) {
		wp_enqueue_script('thickbox');
	}
}

add_action('wp_print_scripts','photopress2_scripts');

function pp2load_tb_fix() {
	global $photopress2_options;
	$pageslug = $photopress2_options['pagename'];
	$page_id = photopress2_get_id_by_slug($pageslug);
	if (($photopress2_options['thickbox'] == 'yes') && (is_active_widget('widget_pp2widg') || ($_GET['page_id'] == $page_id) || ($_GET['pagename'] == $photopress2_options['pagename']) || (get_query_var('pagename') == $photopress2_options['pagename']))) {
		echo "\n" . '<script type="text/javascript">tb_pathToImage = "' . get_option('siteurl') . '/wp-includes/js/thickbox/loadingAnimation.gif";tb_closeImage = "' . get_option('siteurl') . '/wp-includes/js/thickbox/tb-close.png";</script>'. "\n";
	}
}
add_action('wp_footer', 'pp2load_tb_fix');

function photopress2_management() {
	global $wpdb, $tableprefix;
	$table_name = $table_prefix . "photopress2_tags";
	if (isset($_POST['pp2_tag_update'])) {
		$dels = 0;
		$updates = 0;
		foreach ((array)$_POST as $key=>$val) {
			if (is_array($val)) {
				if (($val['delete'] == '1')) {
					$tag = $val['oldtag'];
					$wpdb->query("DELETE FROM $table_name WHERE binary tag = '$tag'");
					$tag_cache = 'pp2_tag_' . $tag;
					delete_transient($tag_cache);
					delete_transient('pp2_tagshtml');
					$dels++;
				} elseif (!empty($val['newtag'])) {
					photopress2_replace_tag($val['oldtag'],$val['newtag']);
					$updates++;
				}
			}
		}
		echo "<div class='updated'>";
      if ($dels > 0) {
         echo $dels . __(' tags deleted. ','photopress2');
      }
      if ($updates > 0) {
         echo $updates . __(' tags updated. ','photopress2');
		}
		echo "</div>\n";
	}
	echo '
	<div class="wrap">
	<h2>' . __('Image Tag Manager','photopress2') . '</h2>
   <p>' . __('You can modify or delete Photopress2 image tags here. Use caution - back up your database first if you are not sure what you are doing. Delete a tag using the check boxes. You can split a tag by entering more than one tag in its place, separating them with commas.','photopress2') . '</p>
	<form name="birthdaze" method="post">
	<p class="submit"><input type="submit" name="Submit" value="' . __('Update','photopress2') . ' &raquo;" /></p>
	<input type="hidden" name="pp2_tag_update" value="update" />
	<table class="widefat tag fixed">
	<thead>
   <tr>
      <th scope="col" class="manage-column">' . __('Tag','photopress2') . '</th>
      <th scope="col" class="manage-column">' . __('Modify','photopress2') . '</th>
      <th scope="col" class="manage-column check-column">' . __('Del','photopress2') . '</th>
   </tr>
	</thead>

	<tfoot>
   <tr>
      <th scope="col" class="manage-column">' . __('Tag','photopress2') . '</th>
      <th scope="col" class="manage-column">' . __('Modify','photopress2') . '</th>
      <th scope="col" class="manage-column check-column">' . __('Del','photopress2') . '</th>
   </tr>
	</tfoot>

	<tbody class="list:tag">';
	$tags = (array)photopress2_taglist();
	$i = 1;
	foreach ($tags as $tag) {
		if (($i%2) == 1) {
			echo '<tr class="alternate">';
		} else {
			echo '<tr>';
		}
		echo '
      <td><input type="hidden" name="row' . $i . '[oldtag]" value="' . $tag . '" />' . $tag . '</td>
      <td><input type="text" name="row' . $i . '[newtag]" value="" size="20" /></td>
      <td><input type="checkbox" name="row' . $i . '[delete]" value="1" /></td>
   </tr>';
		$i++;
	}
   echo '
	</tbody>
	</table>
	<p class="submit"><input type="submit" name="Submit" value="' . __('Update','photopress2') . ' &raquo;" /></p>
	</form>
   </div>';
}

function photopress2_add_management_page() {
   add_management_page('Image Tags', 'Image Tags', 'upload_files', basename(__FILE__), 'photopress2_management');
}

add_action('admin_menu', 'photopress2_add_management_page');

function photopress2_replace_tag($old,$new) {
	global $table_prefix, $wpdb;
	$table_name = $table_prefix . "photopress2_tags";
	$newtags = trim($new);
	$newtags = trim($newtags,',');
	if (strpos($newtags,',')) { // more than one tag
		$tagsarray = explode(',',$newtags);
		$attachids = (array)photopress2_images_in_tag($old);
		$wpdb->query("DELETE FROM $table_name WHERE binary tag='$old';");
		foreach ($tagsarray as $tag) {
			$sanitag = trim($tag);
			$sanitag = sanitize_title_with_dashes($sanitag);
			foreach ($attachids as $attachid) {
				$wpdb->query("INSERT INTO $table_name SET tag='$sanitag', attachid='$attachid';");
			}
		}
		$tag_cache = 'pp2_tag_' . $old;
		delete_transient($tag_cache);
	} else { // no commas so only one tag to change
		$sanitag = trim($new);
		$sanitag = sanitize_title_with_dashes($sanitag);
		$wpdb->query("UPDATE $table_name SET tag='$sanitag' WHERE binary tag='$old';");
		$tag_cache = 'pp2_tag_' . $old;
		delete_transient($tag_cache);
	}
	delete_transient('pp2_tagshtml');
}

?>
